#
# Conditional build:
%bcond_without	tests		# do not perform "make test"

%define		pdir	Test
%define		pnam	Deep
%include	/usr/lib/rpm/macros.perl
Summary:	Test::Deep - Extremely flexible deep comparison
Summary(pl.UTF-8):	Test::Deep - bardzo elastyczne głębokie porównania
Name:		perl-Test-Deep
Version:	1.124
Release:	2
# same as perl
License:	GPL v1+ or Artistic
Group:		Development/Languages/Perl
Source0:	http://www.cpan.org/modules/by-module/Test/%{pdir}-%{pnam}-%{version}.tar.gz
# Source0-md5:	8dac53b90c5d7858694a08f55b05d70e
URL:		http://search.cpan.org/dist/Test-Deep/
BuildRequires:	perl-devel >= 1:5.8.0
BuildRequires:	rpm-perlprov >= 4.1-13
%if %{with tests}
BuildRequires:	perl-Scalar-List-Utils >= 1.09
BuildRequires:	perl-Test-Simple >= 0.88
# _ is temporary workaround for perl decimal version comparison: perl 5.24 provides 0.28 (not 0.280)
BuildRequires:	perl-Test-Tester >= 0.10_7
%endif
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Test::Deep gives you very flexible ways to check that the result you
got is the result you were expecting. At it's simplest it compares two
structures by going through each level, ensuring that the values
match, that arrays and hashes have the same elements and that
references are blessed into the correct class. It also handles
circular data structures without getting caught in an infinite loop.

Where it becomes more interesting is in allowing you to do something
besides simple exact comparisons. With strings, the eq operator checks
that 2 strings are exactly equal but sometimes that's not what you
want. When you don't know exactly what the string should be but you do
know some things about how it should look, eq is no good and you must
use pattern matching instead. Test::Deep provides pattern matching for
complex data structures.

%description -l pl.UTF-8
Test::Deep udostępnia bardzo elastyczne sposoby sprawdzania, czy
otrzymany wynik jest tym, który był oczekiwany. W najprostszym
przypadku porównuje dwie struktury przechodząc po każdym poziomie,
sprawdzając czy wartości się zgadzają, czy tablice i hasze mają te
same elementy i czy referencje są pobłogosławione do właściwych klas.
Obsługuje także zapętlone struktury danych bez wpadania w nieskończoną
pętlę.

Bardziej interesujące jest to, że pozwala na robienie czegoś więcej
niż proste przyrównania. Dla łańcuchów znaków operator eq sprawdza,
czy 2 łańcuchy są dokładnie takie same, ale czasem nie jest to tym, co
chcemy. Jeśli nie wiemy dokładnie, jaki powinien być łańcuch, ale
wiemy coś o tym, jak powinien wyglądać - Test::Deep pozwala na
dopasowywanie wzorców dla złożonych struktur danych.

%prep
%setup -q -n %{pdir}-%{pnam}-%{version}

%build
%{__perl} Makefile.PL \
	INSTALLDIRS=vendor
%{__make}

%{?with_tests:%{__make} test}

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc Changes README TODO
%{perl_vendorlib}/Test/Deep.pm
%{perl_vendorlib}/Test/Deep
%{_mandir}/man3/Test::Deep*.3pm*
%changelog
* Mon Nov 07 2016 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/perl-Test-Deep.git;a=log;h=auto/th/perl-Test-Deep-1.124-2

* Sun Nov 06 2016 Jakub Bogusz <qboosh@pld-linux.org> ecadcaf
- temporary workaround for perl-Test-Tester versioning; release 2

* Sun Nov 06 2016 Jakub Bogusz <qboosh@pld-linux.org> af0d12c
- updated to 1.124

* Sat Jun 22 2013 Jakub Bogusz <qboosh@pld-linux.org> 40800c7
- updated to 0.110

* Sun May 27 2012 Jakub Bogusz <qboosh@pld-linux.org> 3b6eabb
- updated to 0.109

* Thu Feb 24 2011 Jakub Bogusz <qboosh@pld-linux.org> b7292e8
- updated to 0.108

* Sat Dec 04 2010 Elan Ruusamäe <glen@pld-linux.org> 4a58ff1
- release 2

* Wed Sep 09 2009 amateja <amateja@pld-linux.org> e0b15e6
- updated to 1.106
- adapterized

* Sun Dec 14 2008 Maciej Pijanka <agaran@pld-linux.org> a67ece0
- up to 0.103

* Sun Dec 30 2007 zbyniu <zbyniu@pld-linux.org> 2bf88c9
- up to 0.099

* Thu Jul 12 2007 Sławomir Paszkiewicz <paszczus@pld-linux.org> 09eb66b
- updated to 0.096

* Tue Feb 13 2007 Elan Ruusamäe <glen@pld-linux.org> 3268666
- tabs in preamble

* Mon Feb 12 2007 Jan Rękorajski <baggins@pld-linux.org> cfbf0a5
- converted to UTF-8

* Sat Nov 19 2005 Jakub Bogusz <qboosh@pld-linux.org> f639864
- pl, generic URL

* Fri Nov 18 2005 migo <migo@pld-linux.org> 66ac57e
- initial revision

